#include <stdio.h>

#define VectorCopy(a,b)	\
(						\
	b[0]	= a[0],		\
	b[1]	= a[1],		\
	b[2]	= a[2]		\
)

#define CAR_MAX_BODY_TRIS	1024
#define CAR_MAX_BODY_VERTS	768
#define CAR_MAX_WHEEL_TRIS	128
#define CAR_MAX_WHEEL_VERTS	64

typedef struct CAR_Triangle_s
{
	int		I[3];
	float	U[3];
	float	V[3];
} CAR_Triangle_t;

typedef struct CAR_Part_Body_s
{
	float			Origin[3];
	int				NumVertices;
	int				NumTriangles;
	float			Verts[CAR_MAX_BODY_VERTS][3];
	float			Norms[CAR_MAX_BODY_VERTS][3];
	CAR_Triangle_t	Tris[CAR_MAX_BODY_TRIS];
} CAR_Part_Body_t;

typedef struct CAR_Part_Wheel_s
{
	float			Origin[3];
	int				NumVertices;
	int				NumTriangles;
	float			Verts[CAR_MAX_WHEEL_VERTS][3];
	float			Norms[CAR_MAX_WHEEL_VERTS][3];
	CAR_Triangle_t	Tris[CAR_MAX_WHEEL_TRIS];
} CAR_Part_Wheel_t;

typedef struct CAR_Header_s 
{
	int					Version;

	CAR_Part_Body_t		Body;
	CAR_Part_Wheel_t	Wheel[4];
}   CAR_Header_t;