#include	<stdio.h>
#include	<stdlib.h>
#include	<windows.h>
#include	<gl/gl.h>

/*
=============
TARGA LOADING
=============
*/

int		texture;
int		image_bpp;
int		image_width;
int		image_height;
byte	*image_rgba;

/*
=======
LoadMRT
=======
*/
void LoadMRT (FILE *fin)
{
	int				row, rows, column, columns;
	byte			*pixbuf, b1 ,b2;

	b1				= fgetc(fin);
	b2				= fgetc(fin);
	image_width		= b1+(b2*256);

	b1				= fgetc(fin);
	b2				= fgetc(fin);
	image_height	= b1+(b2*256);

	image_bpp		= fgetc(fin);

	rows			= image_height;
	columns			= image_width;
	image_rgba		= malloc (image_width * image_height * 3);

	for (row=0; row<rows; row++)
	{
		pixbuf = image_rgba + row*columns*3;
		for (column=0; column<columns; column++) 
		{
			pixbuf[0] = getc(fin);
			pixbuf[1] = getc(fin);
			pixbuf[2] = getc(fin);
			pixbuf	 += 3;
		}
	}

	fclose(fin);
}

extern char modelpath[260];

int LoadTexture ()
{
	FILE	*fin;
	char	*in;
	char	*out;

	in	= modelpath;
	out	= modelpath;

	while (*in && *in != '.')
		*out++ = *in++;
	*out = 0;

	sprintf (modelpath, "%s.mrt", modelpath);

	fin = fopen (modelpath, "rb");

	if (!fin)
	{
		return FALSE;
	}

	LoadMRT (fin);

	glGenTextures (1, &texture);
	glBindTexture (GL_TEXTURE_2D, texture);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, image_width, image_height, 0, GL_RGB, GL_UNSIGNED_BYTE, image_rgba);

	free (image_rgba);

	glBindTexture (GL_TEXTURE_2D, texture);

	return TRUE;
}